Loading issues with custom host statuses
10/27/2015 09:59 AM - Marek Hulan

Status: Resolved
Priority: Normal
Assignee: Marek Hulén
Category: Plugin integration

Target version:

Difficulty: Fixed in Releases:
Triaged: Found in Releases: 1.10.0
Bugzilla link: Red Hat JIRA:
Pull request: https://github.com/theforeman/foreman/p
ull/2867
Description

When adding custom host status that is namespaced under HostStatus module it's easy to get loading issues in test and production
env if user defines his or her status like this

module HostStatus
class MyStatus < HostStatus::Status
end

end

Rails loads engine files first so it thinks that HostStatus is defined in custom status file and it fails to find HostStatus.status_registry.

A solution is to load HostStatus module in core initializer (downside is that it won't be auto reloaded but it shouldn't matter in this
case), so all engines can rely on this module being loaded.

A workaround for plugins is to define their statuses like class HostStatus::MyStatus < HostStatus::Status which would enforce the
module loading.

To reproduce, either use production/test env or turn on config.cache_classes in config/environments/development.rb, define custom
status from an engine and try starting server. Since host statuses were introduced in 1.10, setting this also as target version.

History

#1 - 10/27/2015 10:03 AM - The Foreman Bot

- Status changed from Assigned to Ready For Testing

- Pull request https://github.com/theforeman/foreman/pull/2867 added
- Pull request deleted ()

#2 - 12/11/2015 06:43 AM - Dominic Cleal

- translation missing: en.field_release changed from 63 to 104

#3 - 01/04/2016 06:59 AM - Dominic Cleal

- translation missing: en.field_release deleted (104)

#4 - 03/16/2016 12:00 PM - Marek Hulan
- Status changed from Ready For Testing to Feedback

Will reopen when | get the reproducer outside of my env.
#5 - 04/20/2016 03:58 AM - Marek Hulan

FTR | retested on clean machine with the Dominic's reproducer and | was unable to reproduce. Not sure what caused it before then. Sorry for false
alarm.
#6 - 05/17/2017 11:25 AM - Anonymous

- Status changed from Feedback to Resolved
